#include <config.h>

#include <stdio.h>
#include <string.h>
#include <glib.h>
#include <time.h>

#include "gtoonz.h"

/********************************************************************
 *                     CARTOON FUNCTION PROTOTYPE                   *
 * void cartoon_name (Cartoon *cartoon, int year, int month, int day);  *
 ********************************************************************/

static void
simple_make_url (Cartoon *cartoon, int year, int month, int day,
			   const char *buffer, int pages)
{
	Item *item;
	int i;

	for (i = 1; i < pages+1; i++) {
		item = g_new0 (Item, 1);
		item->url = g_new (char, strlen(buffer) +10);
		sprintf(item->url, buffer, year, month, day, i);
		cartoon->item_list = g_slist_append (cartoon->item_list, item);
	}
}

static void
sportsseoul_make_url (Cartoon *cartoon, int year, int month, int day,
				      const char *buffer, time_t begin, int pages)
{
	Item *item;
	time_t delta;	/* 1999.4.6 01:00:00 */
	struct tm t;
	int i;

	t.tm_sec = 0; t.tm_min = 0; t.tm_hour = 1;
	t.tm_mday = day; t.tm_mon = month - 1;
	t.tm_year = year-1900;

	delta = ( (mktime(&t)-begin) / (60*60*24) ) \
			- ( (mktime(&t)-begin) / (60*60*24) / 7 );

	for (i = 1; i < pages+1; i++) {
		item = g_new0 (Item, 1);
		item->url = g_new (char, strlen(buffer) +10);
		sprintf(item->url, buffer, delta,i);
		cartoon->item_list = g_slist_append (cartoon->item_list, item);
	}
}
 
static void
ttodi (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www2.hankooki.com/entertain/cartoon/img/03/%d%02d%02d03_0.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
aseak (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www2.hankooki.com/entertain/cartoon/img/07/%d%02d%02d07_0.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
detul (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www2.hankooki.com/entertain/cartoon/img/02/%d%02d%02d02_0.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
mafia (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www2.hankooki.com/entertain/cartoon/img/04/%d%02d%02d04_0.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
haderi (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www2.hankooki.com/entertain/cartoon/img/11/%d%02d%02d11_0.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
tobak (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www2.hankooki.com/entertain/cartoon/img/09/%d%02d%02d09_0.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
blondy (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www2.hankooki.com/entertain/cartoon/img/05/%d%02d%02d05_0.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
skmp (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www2.hankooki.com/entertain/cartoon/img/06/%d%02d%02d06_0.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
simin (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://cartoon2.stoo.com/simin/data/%d%02d%02dsimin_%d.jpg";
	simple_make_url( cartoon, year, month, day, URL, 2 );

	return;
}

static void
melang (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://cartoon2.stoo.com/melang/data/%d%02d%02dmelang_%d.jpg";
	simple_make_url( cartoon, year, month, day, URL, 2 );

	return;
}

static void
wonderful (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://cartoon2.stoo.com/wonderful/data/%d%02d%02dworld_%d.jpg";
	simple_make_url( cartoon, year, month, day, URL, 2 );

	return;
}

static void
gaepae (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://cartoon2.stoo.com/gaepae/data/%d%02d%02dgaepae.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
choong (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://cartoon2.stoo.com/choong/data/%d%02d%02dchoong.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
movie (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://cartoon2.stoo.com/movie/data/%d%02d%02dmovie.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;	
}

static void
arirang (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://cartoon2.stoo.com/arirang/data/%d%02d%02darirang.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;	
}

static void
yasa (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://cartoon2.stoo.com/yasa/data/%d%02d%02dyasa.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;	
}

static void
tazza (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://manhwa.sportschosun.com/enter/cartoon/tazza/image_cartoon/%d%02d%02dc.gif";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;	
}

static void
zombie (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://manhwa.sportschosun.com/enter/cartoon/zombi/image_cartoon/%d%02d%02dk.gif";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;	
}

static void
good (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://manhwa.sportschosun.com/enter/cartoon/good/image_cartoon/%d%02d%02da.gif";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;	
}

static void
henggarae (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://manhwa.sportschosun.com/enter/cartoon/henggarae/image_cartoon/%d%02d%02de.gif";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;	
}

static void
fist (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://manhwa.sportschosun.com/enter/cartoon/fist/image_cartoon/%d%02d%02dj.gif";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;	
}

static void
moodaeri (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www.sportsseoul.com/html/comic/yong/%d/3%d.gif";
	sportsseoul_make_url ( cartoon, year, month, day, URL, 923328000, 4 );
	
	return;	
}

static void
hasu (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www.sportsseoul.com/html/comic/hasu/%d/1%d.gif";
	sportsseoul_make_url ( cartoon, year, month, day, URL, 984972923, 4 );
	
	return;	
}

static void
myth (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www.sportsseoul.com/html/comic/myth/%d/%d.gif";
	sportsseoul_make_url ( cartoon, year, month, day, URL, 1024723819, 6 );
	
	return;	
}

static void
sweet (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www.sportsseoul.com/html/comic/sweet/%d/%d.gif";
	sportsseoul_make_url ( cartoon, year, month, day, URL, 1016148235, 3 );

	return;	
}

static void
sisa (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www.sportsseoul.com/html/comic/sisa/%d/1.gif";
	sportsseoul_make_url ( cartoon, year, month, day, URL, 991934664, 1 );

	return;	
}

static void
sikgaek (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www.donga.com/docs/cartoon/sg/%d%02d/sg%02d%02d_%d.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );
	return;
}


static void
nadaero (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www.donga.com/docs/cartoon/nadaero/%d%02d/me%02d%02d.gif";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
c386 (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://www.donga.com/docs/cartoon/386c/%d%02d/386c%02d%02d.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

static void
snowcat (Cartoon *cartoon, int year, int month, int day)
{
	const char *URL = "http://snowcat.co.kr/diary/%s%02d/%s%02d%02d.gif";
	Item *item;
	char year_s[5] = {0};

	item = g_new0 (Item, 1);
	item->url = g_new (char, strlen(URL) + 10);
	sprintf (year_s, "%d", year);
	sprintf(item->url, URL, year_s + 2, month, year_s + 2, month, day);
	cartoon->item_list = g_slist_append (cartoon->item_list, item);

	return;
}

static void
marineblues (Cartoon *cartoon, int year, int month, int day)
{	
	const char *URL = "http://www.marineblues.net/mb/note/image2/%d-%d.jpg";
	simple_make_url( cartoon, year, month, day, URL, 1 );

	return;
}

CartoonInfo CartoonInfoList[N_CARTOONS] = {
	/* ϰ  */
	{TTODI, N_("ttodi"), &ttodi},
	{ASEAK, N_("aseak"), &aseak},
	{DETUL, N_("detul"), &detul},
	{MAFIA, N_("mafia"), &mafia},
	{HADERI, N_("haderi"), &haderi},
	{TOBAK, N_("tobak"), &tobak},
	{BLONDY, N_("blondy"), &blondy},
	{SKMP, N_("skmp"), &skmp},
	/*   */
	{SIMIN, N_("simin"), &simin},
	{MELANG, N_("melang"), &melang},
	{WONDERFUL, N_("wonderful"), &wonderful},
	{GAEPAE, N_("gaepae"), &gaepae},
	{CHOONG, N_("choong"), &choong},
	{MOVIE, N_("movie"), &movie},
	{ARIRANG, N_("arirang"), &arirang},
	{YASA, N_("yasa"), &yasa},
	/*   */
	{TAZZA, N_("tazza"), &tazza},
	{ZOMBIE, N_("zombie"), &zombie},
	{GOOD, N_("good"), &good},
	{HENGGARAE, N_("henggarae"), &henggarae},
	{FIST, N_("fist"), &fist},
	/*   */
	{MOODAERI, N_("moodaeri"), &moodaeri},
	{HASU, N_("hasu"), &hasu},
	{MYTH, N_("myth"), &myth},
	{SWEET, N_("sweet"), &sweet},
	{SISA, N_("sisa"), &sisa},
	/* Ϻ */
	{SIKGAEK, N_("sikgaek"), &sikgaek},
	{NADAERO, N_("nadaero"), &nadaero},
	{C386, N_("386c"), &c386},
	/*   */
	{SNOWCAT, N_("snowcat"), &snowcat},
	{MARINEBLUES, N_("marineblues"), &marineblues}
};
